#include <stdlib.h>
#include <string.h>
#include <avr/eeprom.h>

#define F_CPU 12500000UL  // 12.5 MHz
#ifndef ALIBC_OLD
#include <util/delay.h>
#else
#include <avr/delay.h>
#endif

#include "ip_arp_udp_tcp.h"
#include "websrv_help_functions.h"
#include "enc28j60.h"

// listen port for tcp/www:
#define MYWWWPORT 80
#define BUFFER_SIZE 1024
static uint8_t buf[BUFFER_SIZE+1];

uint8_t macaddr[6] = {0x54,0x55,0x58,0x10,0x00,0x30}; // mac-
uint8_t gateway[4] = {192,168,1,1}; //  

#define NPORT 20
const uint8_t ports[NPORT] = {PORTA0,PORTA1,PORTA2,PORTA3,PORTA4,PORTA5,PORTA6,PORTA7,PORTC0,PORTC1,PORTC2,PORTC3,PORTC4,PORTC5,PORTC6,PORTC7,PORTD4,PORTD5,PORTD6,PORTD7};
char bport[NPORT+1] = "00000000000000000000\0";   // NPORT      
char bport_a[NPORT+1] = "00000000000000000000\0";   //  <a>

typedef struct {
	char	    domain[21];
	uint8_t		ipaddr[4];
} net_settings;
net_settings netsettings;

net_settings	EEMEM EEMEM_NETSETTINGS;

// declare function
void NetInit(void);



void analyse_get_url(char *str) {
  uint8_t i;
  char strbuf[20];
 
  str++;
  
  if(*str == 0x3F){   // ascii '?'
    if (find_key_val(str,strbuf,20,"d")) {  // domain
      strncpy(netsettings.domain,strbuf,sizeof(strbuf));
		}
    if (find_key_val(str,strbuf,3,"i")) {  // ip1
      netsettings.ipaddr[0] = 192;
      netsettings.ipaddr[1] = 168;
      netsettings.ipaddr[2] = 1;
      netsettings.ipaddr[3] = atoi(strbuf); // atoi - strtoint  stdlib.h
		}
    eeprom_write_block(&netsettings, &EEMEM_NETSETTINGS, sizeof(netsettings));
    return;
  }
  
  
  for(i=0;i<NPORT;i++){
    
    if(*str == 0x31){ // ascii '1'
      if(i<8)PORTA|=(1<<ports[i]);
        else if(i<16)PORTC|=(1<<ports[i]);
          else PORTD|=(1<<ports[i]);
    } else {
      if(i<8)PORTA&=~(1<<ports[i]);
        else if(i<16)PORTC&=~(1<<ports[i]);
          else PORTD&=~(1<<ports[i]);
    }
    str++;
  }  
}



//    EEPROM
void read_settings (void) {
	uint8_t i, result = 0;

	eeprom_read_block(&netsettings, &EEMEM_NETSETTINGS, sizeof(netsettings));

	//domain
	if (netsettings.domain[0]==''){
		strncpy(netsettings.domain,"conture.by\0",11);
  }

	//ipaddr
	result = 0;
	for (i=0; i < 4; i++) {
		if (netsettings.ipaddr[i] == 0xFF)
			result++;
	}
	if (result == 4) {
		netsettings.ipaddr[0] = 192;
		netsettings.ipaddr[1] = 168;
		netsettings.ipaddr[2] = 1;
		netsettings.ipaddr[3] = 99;
	}

}







uint16_t http200ok(void) {
  return(fill_tcp_data_p(buf,0,PSTR("HTTP/1.1 200 OK\r\nContent-Type: text/html\r\nCache-Control: no-cache\r\n\r\n")));
}

//  
void NetInit(void) {
  enc28j60Init(macaddr);
  enc28j60clkout(2); //    12.5MHz
  _delay_loop_1(0); //  60us
  enc28j60PhyWrite(PHLCON,0x476);
  init_ip_arp_udp_tcp(macaddr, netsettings.ipaddr, MYWWWPORT);
  client_set_gwip(gateway);
}


int main(void){
		uint16_t plen;
    uint16_t dat_p;
    uint8_t i, n;
    char tmp[2] = "0\0";
    
    DDRA = 0xFF; //    
    DDRC = 0xFF;
    DDRD = 0xF0;
    
    read_settings();
    

		DDRB|=(1<<DDB7); // SCK

    PORTA = 0x00;
    PORTC = 0x00;
    PORTD = 0x00;

  NetInit();

  while(1){

    plen=enc28j60PacketReceive(BUFFER_SIZE, buf);
    buf[BUFFER_SIZE]='\0';
    dat_p=packetloop_icmp_tcp(buf,plen);
      
      if(dat_p==0){
        goto UDP;
      }

      if (strncmp("GET ",(char *)&(buf[dat_p]),4)!=0){
        plen=http200ok();
        plen=fill_tcp_data_p(buf,plen,PSTR("<h1>200 OK</h1>"));
        goto SENDTCP;
      }
      if (strncmp("/ ",(char *)&(buf[dat_p+4]),2)==0){
      
        for(i=0;i<NPORT;i++) {
          if(i<8){
            if((PORTA & (1<<ports[i]))==(1<<ports[i])) bport[i] = '1';
              else bport[i] = '0';
          }else if(i<16){
            if((PORTC & (1<<ports[i]))==(1<<ports[i])) bport[i] = '1';
              else bport[i] = '0';        
          }else{
            if((PORTD & (1<<ports[i]))==(1<<ports[i])) bport[i] = '1';
              else bport[i] = '0';           
          }
        }
        
        plen=http200ok();
        if(netsettings.domain[0] == 0x30){  // ascii '0'
          plen=fill_tcp_data_p(buf,plen,PSTR("<h1>"));
          for(i=0;i<NPORT;i++){
            for(n=0;n<NPORT;i++){
              bport_a[n] = bport[n];
            }
            plen=fill_tcp_data_p(buf,plen,PSTR("<a href='"));
            if(bport_a[i] == '0')bport_a[i] = '1';
              else bport_a[i] = '0';
            plen=fill_tcp_data(buf,plen,bport_a);
            plen=fill_tcp_data_p(buf,plen,PSTR("'>"));
            tmp[0] = bport[i];
            plen=fill_tcp_data(buf,plen,tmp);
            plen=fill_tcp_data_p(buf,plen,PSTR("</a>"));
          }
          plen=fill_tcp_data_p(buf,plen,PSTR("</h1>"));

        }else{
          plen=fill_tcp_data_p(buf,plen,PSTR("<!DOCTYPE HTML>\n"));
          plen=fill_tcp_data_p(buf,plen,PSTR("<html>\n"));
        
          plen=fill_tcp_data_p(buf,plen,PSTR("<head>\n"));
          plen=fill_tcp_data_p(buf,plen,PSTR("<meta http-equiv='content-type' content='text/html; charset=utf-8' />\n"));
          plen=fill_tcp_data_p(buf,plen,PSTR("<script type='text/javascript' src='http://"));
          plen=fill_tcp_data(buf,plen,netsettings.domain);
          plen=fill_tcp_data_p(buf,plen,PSTR("/eth/jquery.js'></script>\n"));
          plen=fill_tcp_data_p(buf,plen,PSTR("<script type='text/javascript' src='http://"));
          plen=fill_tcp_data(buf,plen,netsettings.domain);
          plen=fill_tcp_data_p(buf,plen,PSTR("/eth/script.js'></script>\n"));
          plen=fill_tcp_data_p(buf,plen,PSTR("<link href='http://"));
          plen=fill_tcp_data(buf,plen,netsettings.domain);
          plen=fill_tcp_data_p(buf,plen,PSTR("/eth/styles.css' rel='stylesheet'>\n"));
          plen=fill_tcp_data_p(buf,plen,PSTR("</head>\n"));
        
          plen=fill_tcp_data_p(buf,plen,PSTR("<body>\n<div class='ports'>"));
          plen=fill_tcp_data(buf,plen,bport);
          plen=fill_tcp_data_p(buf,plen,PSTR("</div>\n"));
          plen=fill_tcp_data_p(buf,plen,PSTR("</body>\n"));
          plen=fill_tcp_data_p(buf,plen,PSTR("</html>"));          
          
        }

        goto SENDTCP;
      }
      
      analyse_get_url((char *)&(buf[dat_p+4]));
      
      plen=http200ok();
      

      for(i=0;i<NPORT;i++){
          if(i<8){
            if((PORTA & (1<<ports[i]))==(1<<ports[i])) bport[i] = '1';
              else bport[i] = '0';
          }else if(i<16){
            if((PORTC & (1<<ports[i]))==(1<<ports[i])) bport[i] = '1';
              else bport[i] = '0';        
          }else{
            if((PORTD & (1<<ports[i]))==(1<<ports[i])) bport[i] = '1';
              else bport[i] = '0';           
          }
      }
      plen=fill_tcp_data(buf,plen,bport); //  
      if(netsettings.domain[0] == 0x30) {
        plen=fill_tcp_data_p(buf,0,PSTR("\n<script>document.location.href = '/';</script>"));
      }

    SENDTCP:
      www_server_reply(buf,plen); // send data
      continue;
    UDP: ;
  }
  return (0);
}
